from direct.gui.DirectGui import *
import direct.directbase.DirectStart
from direct.actor.Actor import Actor
from pandac.PandaModules import DirectionalLight, VBase4
from functools import partial
import math
base.disableMouse ()

# Forma alternativa de cargar un modelo con animaciones,
# cargamos el modelo de un nino con cara de cabron.
ralph_node = Actor ('models/ralph.egg.pz',
                    { 'run' : 'models/ralph-run.egg.pz'})
ralph_node.reparentTo (render)
ralph_node.setBlend (frameBlend = True)

# Le regalamos un juguete al nino y lo ponemos en su mano.
ship_node = loader.loadModel ('models/ship.bam')
ship_node.reparentTo (ralph_node.exposeJoint (
    None, 'modelRoot', 'RightHand'))
ship_node.setScale (.2)

# Ponemos una luz encima del nino.
light_node = ralph_node.attachNewNode (
    DirectionalLight ('ralph-light'))
light_node.node ().setColor (VBase4 (1., .5, .5, 1.))
light_node.setPos (0, 0, 10)
light_node.lookAt (0, 0, 0)
light_node.reparentTo (ralph_node)
render.setLight (light_node)

def circles_task (node, task):
    node.setPos (math.sin (task.time) * 10.0,
                 math.cos (task.time) * 10.0, 0)
    node.setHpr (- (task.time * 180 / math.pi - 90), 0, 0)
    return task.cont

camera.setPos (30, 0, 30)
camera.lookAt (0, 0, 0)

texto = OnscreenText (
    text      = "Bienvenido al juego de Ralf dando vueltas.",
    scale     = .07,
    mayChange = True)
DirectButton (
    text      = "Botoncillo",
    pos       = (0, 0, -.15),
    scale     = .1,
    command   = lambda: texto.setText ("Boton pulsado!"))

taskMgr.add (partial (circles_task, ralph_node), 'circles')
ralph_node.loop ('run')
run ()
